PGOBLIN_BANG(-f)
  Copyright (C)2019..2022 @BABOLO http://www.babolo.ru/
  pkg = cipalite
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: version.pgoblin.m4,v 1.4 2022/11/20 20:45:42 babolo Exp $

#echo    Q
##D pgo0
## +L1
:
## +V2
-
## +L3
## +L5
.
## +V4
 <> 
## -V0


##Q copy E
#style   00Q00Q
Q
#style   00Q00D
D
#file    N
/dev/null
#job     00001
local -zz 1
#connect 0001
sqlite3 :memory:
GETARG(, 1, _)
#select  a001
SELECT a FROM a WHERE i == 0 AND regexp('^[-0-9a-zA-Z_]+$', a) LIMIT 1;
#select  _0a1
SELECT 'sqlite3 WWWROOT/' || ?1 || '/var/www/' || ?1 || '.sqlite'
#connect 0_02
#close   _0_
#perform 0001
CREATE TEMP TABLE o(src text);
#perform 0001
INSERT INTO o(src) VALUES('http://www.b.babolo.ru/src/');
#perform 0001
CREATE TEMP TABLE c(i int, c text);
#trap
#return
#cat     1
/usr/local/etc/babolover.cf
#getstr  201
#copyin  0021
COPY c FROM stdin;
#wait
#untrap
#close 101
#close 202
#perform 0001 
DELETE FROM c WHERE NOT (c REGEXP '^[ 	]*src[ 	]+');
#perform 0001
DELETE FROM c WHERE i <> (SELECT MIN(i) FROM c);
#perform 0001
UPDATE c SET c = trim(c, ' 	');
#perform 0001
UPDATE c SET c = substr(c, 5);
#perform 0001
UPDATE c SET c = trim(c, ' 	');
#select  _001
SELECT c FROM c ORDER BY i LIMIT 1;
#perform 00_1
UPDATE o SET src = ?;
#close   _0_
#perform 0001
CREATE TEMP TABLE d(i int, d text); --   #getdir
#perform 0002
CREATE TEMP TABLE v(m text, p text, a int, i text); --  (pkg, protover, major, minor)
#perform 0001
CREATE TEMP TABLE m(m text, p text); --   (pkg, protover)
#echo    _
PREFIX/include/babolo
#getdir  10_
0x03
#copyin  0011
COPY d;
#close   101
#job     00001
local -Z 1
#perform 0001
DELETE FROM d WHERE NOT regexp('\.VERSION$', d.d);
#perform 0001
UPDATE d SET d == substr(d.d, 1, length(d.d) - 8);
#perform 0001
INSERT INTO m(m) SELECT d.d FROM d WHERE NOT regexp(':', d.d);
#perform 0001
DELETE FROM d WHERE d.d IN(SELECT m.m FROM m);
#perform 0001
INSERT INTO m(m, p)
 SELECT substr(d.d, 1, instr(d.d, ':') - 1)
      , substr(d.d, instr(d.d, ':') + 1, length(d.d))
  FROM d
;
#select  1001
SELECT 'BINDIR/pgoblin'
     , '-X/tmp/t'
     , '-e
##echo    Q
###Q copy
##style   00Q00Q
Q
##connect 0003
sqlite2 :memory:
##perform 0003
CREATE TEMP TABLE m(m text, p text);
##perform 0003
CREATE TEMP TABLE v(v text);
##perform 0003
INSERT INTO m(m, p)
 VALUES(' || quote_literal(m.m) || ', ' || COALESCE(quote_literal(m.p), 'NULL') || ')
;
##select  1003
SELECT ''/bin/cat'', ''PREFIX/include/babolo/'' || m.m || COALESCE('':'' || m.p, '''') || ''.VERSION''
 FROM m
;
##exec    21
##copyin  0023
COPY v
##close   202
##select  1003
SELECT m.m
     , m.p
     , substr(v.v, 1, instr(v.v, ''.'') - 1)
     , substr(v.v, instr(v.v, ''.'') + 1
     , length(v.v))
 FROM m, v
;
##display 00100Q
'FROM m
;
#exec    21N01
#copyin  0022
COPY v FROM stdin
#wait    00001
#close   202
#perform 0002
CREATE TEMP TABLE s(n text, a int, i text); --   (pkg, major, minor)
#exec    2
/usr/bin/fetch
#
-qo
#
-
#
http://www.b.babolo.ru/src/
#exec    302
/usr/bin/awk
#
/^<tr><td.*td><td><a href="/{
    sub(/^<tr><td.*td><td><a href="/, "")
    sub(/">.*$/, "")
    sub(/\.gz$/, "")
    sub(/\.bz2$/, "")
    sub(/\.tar$/, "")
    if  (/^[-_A-Za-z0-9--ߣ]+-[0-9]+\.[0-9]+[a-z]*$/) {
        a1 = $0
        a2 = $0
        sub(/-[0-9]+\.[0-9]+[a-z]*$/, "", a1)
        sub("^" a1 "-", "", a2)
        b1 = a2
        b2 = a2
        sub(/\.[0-9]+[a-z]*$/, "", b1)
        sub("^" b1 "\.", "", b2)
        print a1 "	" b1 "	" b2
}   }
#copyin 0032
COPY s FROM stdin;
#wait
#close 202
#close 303
#close   202
#select  _002
SELECT SQNM(version).SQAT(pkg)
     , SQNM(version).SQAT(protover)
     , SQNM(version).SQAT(major)
     , SQNM(version).SQAT(minor)
     , a
     , i
 FROM SQNM(version), v
 WHERE SQNM(version).SQAT(pkg) == m
   AND SQNM(version).SQAT(protover) == p
   AND (  SQNM(version).SQAT(major) <> a
       OR SQNM(version).SQAT(minor) <> i
       )
;
#display 00_00D
#perform 00_2
UPDATE SQNM(version) SET SQAT(major) = ?3, SQAT(minor) = ?4
 WHERE SQNM(version).SQAT(pkg) == ?1 AND SQNM(version).SQAT(protover) == ?2
;
#select  _002
SELECT SQNM(version).SQAT(pkg), NULL, SQNM(version).SQAT(major), SQNM(version).SQAT(minor), a, i
 FROM SQNM(version), v
 WHERE SQNM(version).SQAT(pkg) == m
   AND SQNM(version).SQAT(protover) IS NULL
   AND p IS NULL
   AND (  SQNM(version).SQAT(major) <> a
       OR SQNM(version).SQAT(minor) <> i
       )
;
#display 00_00D
#perform 00_2
UPDATE SQNM(version) SET SQAT(major) = ?3, SQAT(minor) = ?4
 WHERE SQNM(version).SQAT(pkg) == ?1 AND SQNM(version).SQAT(protover) IS NULL
;
#select  _002
SELECT m, p, a, i, NULL, NULL
 FROM v LEFT JOIN SQNM(version) ON(SQNM(version).SQAT(pkg) == m AND SQNM(version).SQAT(protover) == p)
 WHERE SQNM(version).SQAT(pkg) IS NULL AND p IS NOT NULL
;
#display 00_00D
#perform 0002
INSERT INTO SQNM(version)(SQAT(pkg), SQAT(protover), SQAT(major), SQAT(minor))
 SELECT m, p, a, i
  FROM v LEFT JOIN SQNM(version) ON(SQNM(version).SQAT(pkg) == m AND SQNM(version).SQAT(protover) == p)
  WHERE SQNM(version).SQAT(pkg) IS NULL AND p IS NOT NULL
;
#select  _002
SELECT m, NULL, a, i, NULL, NULL
 FROM v
 WHERE m NOT IN(SELECT SQNM(version).SQAT(pkg)
                 FROM SQNM(version)
                 WHERE SQNM(version).SQAT(protover) IS NULL
               )
   AND p IS NULL
;
#perform 0002
INSERT INTO SQNM(version)(SQAT(pkg), SQAT(major), SQAT(minor))
 SELECT m, a, i
  FROM v
  WHERE m NOT IN(SELECT SQNM(version).SQAT(pkg)
                  FROM SQNM(version)
                  WHERE SQNM(version).SQAT(protover) IS NULL
                )
    AND p IS NULL
;
#select  _002
SELECT SQAT(pkg), SQAT(protover), NULL, NULL, SQAT(major), SQAT(minor)
 FROM SQNM(version)
 WHERE NOT EXISTS(SELECT 1
                   FROM v
                   WHERE SQNM(version).SQAT(pkg) == m AND SQNM(version).SQAT(protover) IS p
                 )
;
#display 00_00D
#perform 0002
DELETE FROM SQNM(version)
 WHERE NOT EXISTS(SELECT 1
                   FROM v
                   WHERE SQNM(version).SQAT(pkg) == m AND SQNM(version).SQAT(protover) IS p
                 )
;
#close   101
#select  _002
SELECT n, a, MAX(i) AS i FROM s GROUP BY n, a;
#perform 00_2
UPDATE SQNM(srcs) SET SQAT(minor) = ?3
 WHERE SQNM(srcs).SQAT(pkg) == ?1 AND SQNM(srcs).SQAT(major) == ?2
;
#perform 0002
INSERT OR REPLACE INTO SQNM(srcs)(SQAT(pkg), SQAT(major), SQAT(minor))
 SELECT n, a, i
  FROM s LEFT JOIN SQNM(srcs) ON(n == SQNM(srcs).SQAT(pkg) AND a == SQNM(srcs).SQAT(major))
  WHERE SQNM(srcs).SQAT(pkg) IS NULL
;
#select  _002
SELECT SQNM(srcs).SQAT(pkg), SQNM(srcs).SQAT(major)
 FROM SQNM(srcs) LEFT JOIN s ON(n == SQNM(srcs).SQAT(pkg) AND a == SQNM(srcs).SQAT(major))
  WHERE n IS NULL
;
#perform 00_2
DELETE FROM SQNM(srcs)
  WHERE SQNM(srcs).SQAT(pkg) == ?1 AND SQNM(srcs).SQAT(major) == ?2
;
#
