#
# Copyright (C)2022 @BABOLO http://www.babolo.ru/
# pkg = cipalite
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: ppas.pleaf.m4,v 1.8 2022/08/21 19:06:55 babolo Exp $
#

eval
#select  1002
SELECT SQNM(x).SQAT(cipa)
    || CASE WHEN SQNM(pass).SQAT(flags) & PassAuthName
            THEN ':' || CAST(  ( (SQNM(x).SQAT(sess) * SQNM(cipaconf).SQAT(a3))
                               + SQNM(cipaconf).SQAT(a2)
                               ) % SQNM(cipaconf).SQAT(a1)
                            AS TEXT
                            )
            ELSE ''
       END             AS realm
     , SQNM(x).SQAT(h) AS host
 FROM SQNM(x) JOIN SQNM(sess) USING(SQAT(sess), SQAT(cred)) JOIN SQNM(pass) USING(SQAT(cred))
    , SQNM(cipaconf)
 WHERE SQNM(pass).SQAT(flags) & PassClaimPass
;
#perform 0002
UPDATE SQNM(pass) SET SQAT(flags) = SQNM(pass).SQAT(flags) & ~PassClaimPass
 FROM SQNM(x)
 WHERE SQNM(pass).SQAT(cred) == SQNM(x).SQAT(cred)
   AND SQNM(pass).SQAT(flags) & PassClaimPass
   AND CINM(x).CIAT(cred) > 0
;
#select  _01_
SELECT ? FROM CINM(x) WHERE CINM(x).CIAT(u) == 1 AND CINM(x).CIAT(cred) > 0;
#eval    00_
##style   00y001
exit
##echo    000001
status401
##display 001001
##exit
#close   202
#close   101
#close   _0_
