#
# Copyright (C)2022 @BABOLO http://www.babolo.ru/
# pkg = cipalite
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: shop.pleaf.m4,v 1.2 2022/08/20 14:39:32 babolo Exp $
#

eval
#style   00y001
shop
#select  _002
SELECT SQNM(pass).SQAT(cred)                                                  AS cred
     , SQNM(pass).SQAT(login)                                                 AS login
     , SQNM(pass).SQAT(passwd)                                                AS passwd
     , SQNM(pass).SQAT(ttl)                                                   AS ttl
     , CASE WHEN SQNM(pass).SQAT(flags) & SessClaimPass THEN 'g' ELSE 'r' END AS "SCP"
     , CASE WHEN SQNM(pass).SQAT(flags) & SessAuthName  THEN 'g' ELSE 'r' END AS "SAN"
     , CASE WHEN SQNM(pass).SQAT(flags) & PassClaimPass THEN 'g' ELSE 'r' END AS "PCP"
     , CASE WHEN SQNM(pass).SQAT(flags) & PassAuthName  THEN 'g' ELSE 'r' END AS "PAN"
     , SQNM(pass).SQAT(nickname)
 FROM SQNM(pass) JOIN SQNM(x) USING(SQAT(cred))
 WHERE SQNM(x).SQAT(cred) > 0
ORDER BY SQNM(pass).SQAT(cred)
;
#display 00_001
#close   _0_001
